using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using SimpleJSON;
using UnityEngine;

namespace VaMJapan {
    public class PenisController : MVRScript {
        protected JSONStorableFloat intensity;
        protected JSONStorableFloat ELength;
        protected JSONStorableFloat FLength;
        protected JSONStorableFloat FGirth;
        protected JSONStorableFloat EGirth;
        protected JSONStorableFloat pHeightSlider;
        protected JSONStorableFloat OSize;
        protected JSONStorableFloat pAngleUD;
        protected JSONStorableFloat pCurveUD;
        protected JSONStorableFloat pAngleLR;
        protected JSONStorableFloat pCurveLR;
        protected JSONStorableFloat hardness;
        protected JSONStorableFloat tesAngle;
        protected JSONStorableFloat EGloss;
        protected JSONStorableFloat FGloss;

        protected JSONStorableBool angleCurveBool;
        protected JSONStorableBool adjustableLengthBool;
        protected JSONStorableBool adjustableGirthBool;
        protected JSONStorableBool glossBool;
        protected JSONStorableBool OSizeBool;

        protected JSONStorableFloat gloss;
        protected JSONStorableFloat DBump;
        protected JSONStorableFloat SBump;

        protected FreeControllerV3 pBC;
        protected FreeControllerV3 pMC;
        protected FreeControllerV3 pTC;
        protected FreeControllerV3 tesC;

        protected List<List<float>> timelistlist;

        protected static DAZMorph pLength;
        protected static DAZMorph pHeight;
        protected static DAZMorph pGirth;

        protected static DAZMorph mf0;
        protected static DAZMorph mf1;
        protected static DAZMorph mf2;
        protected static DAZMorph mf3;
        protected static DAZMorph mf4;

        protected static DAZMorph mf00;
        protected static DAZMorph mf11;
        protected static DAZMorph mf22;
        protected static DAZMorph mf33;
        protected static DAZMorph mf44;

        public static float StartToEnd (float t, float min, float max, float start, float end) {
            max -= min;
            t -= start;
            float validtime = end - start;

            if (t >= 0 && t < validtime) {

                t = t * 1 / validtime;

                return max * t + min;
            } else if (t >= validtime) {
                return max + min;
            } else {
                return min;
            }
        }

        public override void Init () {

            JSONStorable geometry = containingAtom.GetStorableByID ("geometry");
            DAZCharacterSelector character = geometry as DAZCharacterSelector;
            GenerateDAZMorphsControlUI morphControl = character.morphsControlUI;

            mf0 = morphControl.GetMorphByDisplayName ("Penis Ctrl 0 (MaF)");
            mf1 = morphControl.GetMorphByDisplayName ("Penis Ctrl 1 (MaF)");
            mf2 = morphControl.GetMorphByDisplayName ("Penis Ctrl 2 (MaF)");
            mf3 = morphControl.GetMorphByDisplayName ("Penis Ctrl 3 (MaF)");
            mf4 = morphControl.GetMorphByDisplayName ("Penis Ctrl 4 (MaF)");
            mf00 = morphControl.GetMorphByDisplayName ("Penis Ctrl Ex 0 (MaF)");
            mf11 = morphControl.GetMorphByDisplayName ("Penis Ctrl Ex 1 (MaF)");
            mf22 = morphControl.GetMorphByDisplayName ("Penis Ctrl Ex 2 (MaF)");
            mf33 = morphControl.GetMorphByDisplayName ("Penis Ctrl Ex 3 (MaF)");
            mf44 = morphControl.GetMorphByDisplayName ("Penis Ctrl Ex 4 (MaF)");

            pLength = morphControl.GetMorphByDisplayName ("Penis Length");
            pGirth = morphControl.GetMorphByDisplayName ("Sh_Girth_XL");
            pHeight = morphControl.GetMorphByDisplayName ("Sh_Height");

            pBC = containingAtom.GetStorableByID ("penisBaseControl") as FreeControllerV3;
            pMC = containingAtom.GetStorableByID ("penisMidControl") as FreeControllerV3;
            pTC = containingAtom.GetStorableByID ("penisTipControl") as FreeControllerV3;
            tesC = containingAtom.GetStorableByID ("testesControl") as FreeControllerV3;

            intensity = new JSONStorableFloat ("Intensity", 0f, SliderCallback, 0f, 1f, true);
            RegisterFloat (intensity);
            CreateSlider (intensity);

            CreateSpacer (false).height = 10f;

            angleCurveBool = new JSONStorableBool ("Enable adjust Angle & Curve ", true, BoolCallback);
            RegisterBool (angleCurveBool);
            CreateToggle (angleCurveBool);

            pAngleUD = new JSONStorableFloat ("Angle U/D at erection", 20f, SliderCallback, -90f, 90f, true);
            RegisterFloat (pAngleUD);
            CreateSlider (pAngleUD);

            pCurveUD = new JSONStorableFloat ("Curve U/D at election", 20f, SliderCallback, -90f, 90f, true);
            RegisterFloat (pCurveUD);
            CreateSlider (pCurveUD);

            pAngleLR = new JSONStorableFloat ("Angle L/R at erection", 0f, SliderCallback, -90f, 90f, true);
            RegisterFloat (pAngleLR);
            CreateSlider (pAngleLR);

            pCurveLR = new JSONStorableFloat ("Curve L/R at election", 0f, SliderCallback, -90f, 90f, true);
            RegisterFloat (pCurveLR);
            CreateSlider (pCurveLR);

            hardness = new JSONStorableFloat ("Hardness", .5f, SliderCallback, 0.01f, 1f, true);
            RegisterFloat (hardness);
            CreateSlider (hardness);

            adjustableLengthBool = new JSONStorableBool ("Adjustable Length (Eat CPU)", false, BoolCallback);
            RegisterBool (adjustableLengthBool);
            CreateToggle (adjustableLengthBool, true);

            FLength = new JSONStorableFloat ("Adjustable Length at flaccid", 0f, SliderCallback, -5f, 10f, true);
            RegisterFloat (FLength);
            CreateSlider (FLength, true);

            ELength = new JSONStorableFloat ("Adjustable Length at erection", 0f, SliderCallback, -5f, 10f, true);
            RegisterFloat (ELength);
            CreateSlider (ELength, true);

            CreateSpacer (true).height = 10f;

            adjustableGirthBool = new JSONStorableBool ("Adjustable Girth (Eat CPU)", false, BoolCallback);
            RegisterBool (adjustableGirthBool);
            CreateToggle (adjustableGirthBool, true);

            FGirth = new JSONStorableFloat ("Adjustable Girth at flaccid", 0f, SliderCallback, -1f, 1f, true);
            RegisterFloat (FGirth);
            CreateSlider (FGirth, true);

            EGirth = new JSONStorableFloat ("Adjustable Girth at erection", 0f, SliderCallback, -1f, 1f, true);
            RegisterFloat (EGirth);
            CreateSlider (EGirth, true);

            CreateSpacer (true).height = 10f;

            OSizeBool = new JSONStorableBool ("Enable Overall Size (Eat CPU)", false, BoolCallback);
            RegisterBool (OSizeBool);
            CreateToggle (OSizeBool, true);

            OSize = new JSONStorableFloat ("Overall Size", 0f, SliderCallback, 0f, 1f, true);
            RegisterFloat (OSize);
            CreateSlider (OSize, true);

            CreateSpacer (true).height = 10f;

            pHeightSlider = new JSONStorableFloat ("Penis Height", pHeight.morphValue, SliderCallback, -1f, 3f, true);
            RegisterFloat (pHeightSlider);
            CreateSlider (pHeightSlider, true);

            CreateSpacer (true).height = 10f;

            glossBool = new JSONStorableBool ("Enable gloss adjust", false, BoolCallback);
            RegisterBool (glossBool);
            CreateToggle (glossBool, true);

            FGloss = new JSONStorableFloat ("Gloss at flaccid", 0f, SliderCallback, 0f, 8f, true);
            RegisterFloat (FGloss);
            CreateSlider (FGloss, true);

            EGloss = new JSONStorableFloat ("Gloss at erection", 8f, SliderCallback, 0f, 8f, true);
            RegisterFloat (EGloss);
            CreateSlider (EGloss, true);

            var timelist = new List<float> ();
            timelist.Add (.25f);
            timelist.Add (.25f);
            timelist.Add (.25f);
            timelist.Add (.25f);

            timelistlist = new List<List<float>> ();

            float currentlistedtime = 0;
            float totallistedtime = timelist.Sum ();

            foreach (float f in timelist) {
                timelistlist.Add (new List<float> () { currentlistedtime / totallistedtime, (currentlistedtime + f) / totallistedtime });
                currentlistedtime += f;
            }

            pLength.morphValue = 0;
            pGirth.morphValue = 0;

            pBC.jointRotationDriveDamper = .1f;
            pMC.jointRotationDriveDamper = .1f;
            pTC.jointRotationDriveDamper = .1f;
            tesC.jointRotationDriveSpring = .01f;
            tesC.jointRotationDriveDamper = .01f;

            JSONStorable skin = containingAtom.GetStorableByID ("skin");

            gloss = skin.GetFloatJSONParam ("Gloss");
            DBump = skin.GetFloatJSONParam ("Diffuse Bumpiness");
            SBump = skin.GetFloatJSONParam ("Specular Bumpiness");

            SliderCallback (intensity);
            BoolCallback (OSizeBool);

        }
        protected void BoolCallback (JSONStorableBool jb) {
            SliderCallback (intensity);

            if (OSizeBool.val != true) {
                mf00.morphValue = mf11.morphValue = mf22.morphValue = mf33.morphValue = mf44.morphValue = 0f;

            }
            JSONStorable skin = containingAtom.GetStorableByID ("skin");
            gloss = skin.GetFloatJSONParam ("Gloss");
            DBump = skin.GetFloatJSONParam ("Diffuse Bumpiness");
            SBump = skin.GetFloatJSONParam ("Specular Bumpiness");

        }
        protected void SliderCallback (JSONStorableFloat jf) {

            if (adjustableLengthBool.val == true) {
                pLength.morphValue = ELength.val - (ELength.val - FLength.val) * (1 - intensity.val);
            }

            if (adjustableGirthBool.val == true) {
                pGirth.morphValue = EGirth.val - (EGirth.val - FGirth.val) * (1 - intensity.val);
            }

            if (pHeight.morphValue != pHeightSlider.val) {
                pHeight.morphValue = pHeightSlider.val;
            }

            float mf1val = StartToEnd (intensity.val, 0f, 1f, timelistlist[0][0], timelistlist[0][1]);
            float mf2val = StartToEnd (intensity.val, 0f, 1f, timelistlist[1][0], timelistlist[1][1]);
            float mf3val = StartToEnd (intensity.val, 0f, 1f, timelistlist[2][0], timelistlist[2][1]);
            float mf4val = StartToEnd (intensity.val, 0f, 1f, timelistlist[3][0], timelistlist[3][1]);

            if (mf0.morphValue != 1f) {
                mf0.morphValue = 1f;
            }

            if (mf1val <= 1f) {
                mf1.morphValue = mf1val;
            }

            if (mf2val <= 1f) {
                mf2.morphValue = mf2val;
            }
            if (mf3val <= 1f) {
                mf3.morphValue = mf3val;
            }

            if (mf4val <= 1f) {
                mf4.morphValue = mf4val;
            }

            if (OSizeBool.val == true) {

                if (mf00.morphValue != OSize.val) {
                    mf00.morphValue = OSize.val;
                }

                if (mf1val <= 1f) {
                    mf11.morphValue = mf1val * OSize.val;
                }

                if (mf2val <= 1f) {
                    mf22.morphValue = mf2val * OSize.val;
                }
                if (mf3val <= 1f) {
                    mf33.morphValue = mf3val * OSize.val;
                }

                if (mf4val <= 1f) {
                    mf44.morphValue = mf4val * OSize.val;
                }
            }

            if (angleCurveBool.val) {
                float jointIntensity = (float) Mathf.Pow (intensity.val, 1.5f);

                pBC.jointRotationDriveXTarget = (1f - jointIntensity) * -45f + pAngleUD.val * jointIntensity;

                pMC.jointRotationDriveXTarget = (1f - jointIntensity) * -10f + pCurveUD.val / 2f * jointIntensity;
                pTC.jointRotationDriveXTarget = (1f - jointIntensity) * -10f + pCurveUD.val / 4f * jointIntensity;

                pBC.jointRotationDriveYTarget = (1f - jointIntensity) + pAngleLR.val * jointIntensity;
                pMC.jointRotationDriveYTarget = (1f - jointIntensity) + pCurveLR.val / 2f * jointIntensity;
                pTC.jointRotationDriveYTarget = (1f - jointIntensity) + pCurveLR.val / 4f * jointIntensity;

                pBC.jointRotationDriveSpring = (1f - jointIntensity) * .3f + hardness.val * 30f * jointIntensity;
                pMC.jointRotationDriveSpring = (1f - jointIntensity) * 1.3f + hardness.val * 30f * jointIntensity;
                pTC.jointRotationDriveSpring = (1f - jointIntensity) * 1.3f + hardness.val * 30f * jointIntensity;
            }

            if (glossBool.val) {
                gloss.val = FGloss.val + (EGloss.val - FGloss.val) * intensity.val;
                DBump.val = intensity.val * .43f;
                SBump.val = intensity.val * 1f;
            }

        }

        private void FixedUpdate () {

        }

    }
}